
#include "SampleWindow.h"

// ------------------------------------------------------------
// SampleWindow.cpp
//
// This class derives from BWindow and defines any behaviour 
// specific to our application.  There are other subclasses of 
// BWindow you can derive from, such as BWindowScreen and 
// BAlert.  For more information like this, please see the 
// Be Book.

// Constructor
SampleWindow::SampleWindow( BRect frame ) :
									BWindow( frame, "Sample Be Application", 
								 			 B_TITLED_WINDOW, B_NOT_RESIZABLE )
{
	frame.OffsetTo(B_ORIGIN);
	
	MyView = new SampleView( frame, "SampleView" );

	// Sets the amount of time between 'Pulses'.  This concept is
	// described further in the comments for SampleView::Pulse()
 	SetPulseRate( 100 );

	// Add the newly-created view to the window's "View Hierarchy"
	AddChild(MyView);
			
	Show();
}


// Code to be executed when the application recieves the 
// B_QUIT_REQUESTED message.  If you do not explicitly 
// define this behaviour (by passing this message up to
// the Application object).  If this returns true, Quit()
// is called, if it returns false, no further action is
// taken.
//
// Note:  The pointer be_app is 'always there'; the
// system sets it up for you, and points it to your
// Application object.
bool
SampleWindow::QuitRequested()
{
	// Pass the B_QUIT_REQUESTED message up to the BApplication
	// The reason that QuitRequested() doesn't just bail out
	// automatically is that you might want to prompt the user
	// to save their changes, etc.  After you are ready to
	// actually quit, post the B_QUIT_REQUESTED message.
	be_app->PostMessage( B_QUIT_REQUESTED );
	return( true );
}

// Code to be executed upon receiving a message.
// We will send the message to the view so it handles it.
void
SampleWindow::MessageReceived( BMessage *message )
{
	switch( message->what ){
		case COLOR_BUTTON_MESSAGE: 
			DispatchMessage( message, MyView );
			break;
	}
}
